package net.jfwu.modeling;

import java.util.Collection;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.google.common.collect.ImmutableMap;
import com.google.common.collect.ImmutableMap.Builder;

public class ModelProvider {
	private final Map<Class<?>, Set<Object>> modelRoots;

	public ModelProvider(Set<Class<?>> modelRootClasses) {
		Builder<Class<?>, Set<Object>> builder = ImmutableMap
				.<Class<?>, Set<Object>> builder();
		for (Class<?> modelRootClass : modelRootClasses)
			builder.put(modelRootClass, new HashSet<Object>());
		this.modelRoots = builder.build();
	}

	public void addRoot(Object modelRoot) {
		for (Class<?> modelRootClass : modelRoots.keySet())
			if (modelRootClass.isInstance(modelRoot))
				modelRoots.get(modelRootClass).add(modelRoot);
	}

	public <T> Collection<T> getEachModelOf(Class<?> modelClass) {
		// TODO
		return null;
	}

	public <T> Collection<T> getEachChildOf(Class<?> modelClass,
			Class<T> childClass) {
		// TODO
		return null;
	}

	public <T> Collection<Collection<T>> getAllChildrenOf(Class<?> modelClass,
			Class<T> childClass) {
		// TODO
		return null;
	}
}
