package net.jfwu.modeling;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.util.Collection;

@Retention(RUNTIME)
@Documented
@Target({ METHOD, FIELD })
@Inherited
public @interface Children {
	Class<?> type();

	Class<? extends Collection<?>> collection();
}
