package net.jfwu.modeling;

import static java.lang.annotation.ElementType.*;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Documented;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.Target;

@Retention(RUNTIME)
@Documented
@Target({ METHOD, FIELD })
@Inherited
public @interface Parent {
	Class<?> value();
}
